VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmTextEditor 
   Caption         =   "Document - Text Editor"
   ClientHeight    =   3915
   ClientLeft      =   3570
   ClientTop       =   2310
   ClientWidth     =   6630
   Icon            =   "frmTextEditor.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3915
   ScaleWidth      =   6630
   WindowState     =   2  'Maximized
   Begin MSComDlg.CommonDialog dlgTextEditor 
      Left            =   3060
      Top             =   1740
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtEditor 
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu Hyphen1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu Hyphen2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFilePrint 
         Caption         =   "&Print..."
         Shortcut        =   ^P
      End
      Begin VB.Menu Hyphen3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuEditCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuEditPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu Hyphen4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditFind 
         Caption         =   "&Find..."
         Shortcut        =   ^F
      End
      Begin VB.Menu mnuEditFindNext 
         Caption         =   "Find &Next"
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuEditReplace 
         Caption         =   "&Replace..."
         Shortcut        =   ^H
      End
   End
   Begin VB.Menu mnuFormat 
      Caption         =   "F&ormat"
      Begin VB.Menu mnuFormatFont 
         Caption         =   "&Font"
      End
   End
End
Attribute VB_Name = "frmTextEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mblnChanged                 As Boolean
Private mblnCancelSave              As Boolean
Private mstrSearchFor               As String

' Printing-related variables
Private mstrPrintFileName           As String
Private mintOrientation             As Integer  ' 1 = portrait, 2 = landscape
Private mintLineCtr                 As Integer
Private mintPageCtr                 As Integer
Private mintLinesPerPage            As Integer
Private mintCharsPerLine            As Integer
Private Const mintLINE_START_POS    As Integer = 6

'-----------------------------------------------------------------------------
Private Sub Form_Resize()
'-----------------------------------------------------------------------------

    txtEditor.Height = frmTextEditor.ScaleHeight
    txtEditor.Width = frmTextEditor.ScaleWidth
    
End Sub

'-----------------------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)
'-----------------------------------------------------------------------------
    
    Dim intUserResponse As Integer
    
    If mblnChanged = True Then
        ' file was changed since last save
        intUserResponse = MsgBox("The file has changed. Do you want to save it?", _
                             vbYesNoCancel + vbQuestion + vbDefaultButton3, _
                             "Basic Text Editor Demo")
        Select Case intUserResponse
            Case vbYes
                ' user wants to save current document
                Call mnuFileSave_Click
                If mblnCancelSave = True Then
                    ' user canceled save
                    ' return to document-don't unload form
                    Cancel = 1
                    mblnCancelSave = False
                End If
            Case vbNo
                ' user does not want to save current document
                ' unload form and exit
            Case vbCancel
                ' return to document-don't unload form
                Cancel = 1
        End Select
    End If
       
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuFileNew_Click()
'-----------------------------------------------------------------------------

    Dim intUserResponse As Integer
    
    If mblnChanged = True Then
        ' current file was changed since last save
        intUserResponse = MsgBox("The current file has changed. " _
                              & "Do you want to save it before starting a new file?", _
                                vbYesNoCancel + vbQuestion + vbDefaultButton3, _
                                "Basic Text Editor Demo")
        Select Case intUserResponse
            Case vbYes
                ' user wants to save current file
                Call mnuFileSave_Click
                If mblnCancelSave = True Then
                    ' user cancelled save
                    mblnCancelSave = False
                    Exit Sub
                End If
            Case vbNo
                ' user does not want to save current file,
                ' proceed with "New" command logic
            Case vbCancel
                ' user wants to cancel New command
                Exit Sub
        End Select
    End If
    
    ' reset for new file
    txtEditor.Text = ""
    mblnChanged = False
    frmTextEditor.Caption = "(Untitled) - Text Editor"
    dlgTextEditor.FileName = ""
    
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuFileOpen_Click()
'-----------------------------------------------------------------------------

    Dim intUserResponse As Integer
    Dim intFileNbr      As Integer
    
    On Error GoTo mnuFileOpen_Click_ErrHandler
    
    If mblnChanged = True Then
        ' current file was changed since last save
        intUserResponse = MsgBox("The current file has changed. " _
                              & "Do you want to save it before opening a new file?", _
                                vbYesNoCancel + vbQuestion + vbDefaultButton3, _
                                "Basic Text Editor Demo")
        Select Case intUserResponse
            Case vbYes
                ' user wants to save current document
                Call mnuFileSave_Click
                If mblnCancelSave = True Then
                    ' user cancelled save
                    mblnCancelSave = False
                    Exit Sub
                End If
            Case vbNo
                ' user doesn't want to save current document, proceed with Open dialog
            Case vbCancel
                ' user wants to cancel Open command
                Exit Sub
        End Select
    End If
    
    With dlgTextEditor
        .CancelError = True
        .Filter = "Text Files(*.txt)|*.txt|All Files(*.*)|*.*"
        .FileName = ""
        .ShowOpen
    End With
    
    intFileNbr = FreeFile
    Open dlgTextEditor.FileName For Input As #intFileNbr
    txtEditor.Text = Input(LOF(intFileNbr), intFileNbr)
    Close #intFileNbr
    
    mblnChanged = False
    
    frmTextEditor.Caption = dlgTextEditor.FileName & " - Text Editor"
    
    Exit Sub
    
mnuFileOpen_Click_ErrHandler:
    Exit Sub
    
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuFileSave_Click()
'-----------------------------------------------------------------------------

    Dim intFileNbr As Integer

    If frmTextEditor.Caption = "(Untitled) - Text Editor" Then
        ' new document
        Call mnuFileSaveAs_Click
    Else
        ' existing document
        SaveCurrentFile
    End If
    
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuFileSaveAs_Click()
'-----------------------------------------------------------------------------

    On Error GoTo mnuFileSaveAs_Click_ErrHandler
    
    With dlgTextEditor
        .CancelError = True
        .Flags = cdlOFNOverwritePrompt + cdlOFNPathMustExist
        .Filter = "Text Files(*.txt)|*.txt"
        .ShowSave
    End With
    
    SaveCurrentFile
    
    frmTextEditor.Caption = dlgTextEditor.FileName & " - Text Editor"
    
    Exit Sub
    
mnuFileSaveAs_Click_ErrHandler:
    mblnCancelSave = True
    Exit Sub
    
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuFilePrint_Click()
'-----------------------------------------------------------------------------

    On Error GoTo mnuFilePrint_Click_ErrHandler
    
    With dlgTextEditor
        .Flags = cdlPDNoSelection + cdlPDHidePrintToFile + cdlPDNoPageNums
        .CancelError = True
        .ShowPrinter
    End With
    
    mintOrientation = dlgTextEditor.Orientation
    
    PrintCurrentFile
    
    Exit Sub

mnuFilePrint_Click_ErrHandler:
    Exit Sub
        
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuFileExit_Click()
'-----------------------------------------------------------------------------

    Unload Me
    
End Sub


'-----------------------------------------------------------------------------
Private Sub mnuEdit_Click()
'-----------------------------------------------------------------------------

    If txtEditor.SelText = "" Then
        ' no text is selected
        mnuEditCut.Enabled = False
        mnuEditCopy.Enabled = False
    Else
        ' some text is selected
        mnuEditCut.Enabled = True
        mnuEditCopy.Enabled = True
    End If
    
    If Clipboard.GetText() = "" Then
        ' no text is on the clipboard
        mnuEditPaste.Enabled = False
    Else
        ' some text is on the clipboard
        mnuEditPaste.Enabled = True
    End If
    
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuEditCut_Click()
'-----------------------------------------------------------------------------

    ' clear the clipboard
    Clipboard.Clear
    
    'send text to clipboard
    Clipboard.SetText txtEditor.SelText
    
    ' remove selected text from text box
    txtEditor.SelText = ""
    
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuEditCopy_Click()
'-----------------------------------------------------------------------------

    ' clear the clipboard
    Clipboard.Clear
    
    ' send text to clipboard
    Clipboard.SetText txtEditor.SelText
    
End Sub

'-----------------------------------------------------------------------------
Private Sub mnuEditPaste_Click()
'-----------------------------------------------------------------------------

    'retrieve text from clipboard and paste into text box
    txtEditor.SelText = Clipboard.GetText()
    
End Sub

'--------------------------------------------------------------------------
Private Sub mnuEditFind_Click()
'--------------------------------------------------------------------------

    If FormIsLoaded("frmFind") Then
        If frmFind.Caption = "Find" Then
            Exit Sub
        Else
            Unload frmFind
        End If
    End If
    
    glngSearchStart = txtEditor.SelStart + 1
    
    With frmFind
        .Caption = "Find"
        .Show
    End With
    
End Sub

'--------------------------------------------------------------------------
Private Sub mnuEditFindNext_Click()
'--------------------------------------------------------------------------

    Dim blnFindAgain    As Boolean

    If gstrSearchString = "" Then
        mnuEditFind_Click
        Exit Sub
    End If

    
    Do
        FindNext
        
        blnFindAgain = False
        
        If Not gblnFindItemFound Then
            If gintRestartFind = vbYes Then
                glngSearchStart = 1
                blnFindAgain = True
            End If
        End If
        
    Loop While blnFindAgain
    
End Sub

'--------------------------------------------------------------------------
Private Sub mnuEditReplace_Click()
'--------------------------------------------------------------------------

    If FormIsLoaded("frmFind") Then
        If frmFind.Caption = "Replace" Then
            Exit Sub
        Else
            Unload frmFind
        End If
    End If
    
    With frmFind
        .Caption = "Replace"
        .Show
    End With

End Sub

'--------------------------------------------------------------------------
Private Sub mnuFormatFont_Click()
'--------------------------------------------------------------------------

    On Error GoTo mnuFormatFont_Click_ErrHandler
    
    With dlgTextEditor
        .CancelError = True
        .Flags = cdlCFBoth Or cdlCFApply
        .ShowFont
        txtEditor.FontName = .FontName
        txtEditor.FontSize = .FontSize
        txtEditor.FontItalic = .FontItalic
        txtEditor.FontBold = .FontBold
    End With
    
    Exit Sub
    
mnuFormatFont_Click_ErrHandler:
    Exit Sub
    
End Sub

'-----------------------------------------------------------------------------
Private Sub txtEditor_Change()
'-----------------------------------------------------------------------------
    mblnChanged = True
End Sub

'-----------------------------------------------------------------------------
Private Sub SaveCurrentFile()
'-----------------------------------------------------------------------------
    
    Dim intFileNbr As Integer

    intFileNbr = FreeFile
    Open dlgTextEditor.FileName For Output As #intFileNbr
    Print #intFileNbr, txtEditor.Text
    Close #intFileNbr
    
    mblnChanged = False

End Sub

'-----------------------------------------------------------------------------
Private Sub PrintCurrentFile()
'-----------------------------------------------------------------------------
    
    Dim astrParags()        As String
    Dim strCurrLine         As String
    Dim intX                As Integer
    Dim intStart            As Integer
    Dim intBlankPos         As Integer
    Dim blnParagComplete    As Boolean
   
    ' Set the printer font to Courier, if available (otherwise, we would be
    ' relying on the default font for the Windows printer, which may or
    ' may not be set to an appropriate font) ...
    For intX = 0 To Printer.FontCount - 1
        If Printer.Fonts(intX) Like "Courier*" Then
            Printer.FontName = Printer.Fonts(intX)
            Exit For
        End If
    Next
    
    Printer.FontSize = 10
    Printer.Orientation = mintOrientation
    
    ' set limits based on orientation
    If Printer.Orientation = vbPRORPortrait Then
        mintLinesPerPage = 60
        mintCharsPerLine = 80
    Else
        mintLinesPerPage = 47
        mintCharsPerLine = 118
    End If
    
    ' set filename as it will appear in the heading
    mstrPrintFileName = dlgTextEditor.FileName
    mstrPrintFileName = Mid$(mstrPrintFileName, InStrRev(mstrPrintFileName, "\") + 1)
    If Len(mstrPrintFileName) > (mintCharsPerLine - 21) Then
        mstrPrintFileName = Right$(mstrPrintFileName, (mintCharsPerLine - 21))
    End If
    
    ' initialize page counter ...
    mintPageCtr = 0
    
    ' print first page headings
    PrintHeadings
    
    astrParags = Split(txtEditor.Text, vbNewLine)
    
    For intX = 0 To UBound(astrParags)
        blnParagComplete = False
        intStart = 1
        Do Until blnParagComplete
            If mintLineCtr > mintLinesPerPage Then
                PrintHeadings
            End If
            strCurrLine = Mid$(astrParags(intX), intStart, mintCharsPerLine)
            If Len(strCurrLine) < mintCharsPerLine Then
                blnParagComplete = True
            ElseIf Right$(strCurrLine, 1) = " " Then
                intStart = intStart + mintCharsPerLine
            ElseIf Mid$(astrParags(intX), intStart + mintCharsPerLine, 1) = " " Then
                intStart = intStart + mintCharsPerLine + 1
            Else
                intBlankPos = InStrRev(strCurrLine, " ")
                If intBlankPos = 0 Then
                    intStart = intStart + mintCharsPerLine
                Else
                    intStart = intBlankPos + 1
                    strCurrLine = Left$(strCurrLine, intBlankPos - 1)
                End If
            End If
            Printer.Print Tab(mintLINE_START_POS); strCurrLine
            mintLineCtr = mintLineCtr + 1
        Loop
    Next
            
    ' Important! When done, the EndDoc method of the Printer object must be invoked.
    ' The EndDoc method terminates a print operation sent to the Printer object,
    ' releasing the document to the print device or spooler.
    Printer.EndDoc

End Sub

'-----------------------------------------------------------------------------
Private Sub PrintHeadings()
'-----------------------------------------------------------------------------
    
    ' If we are about to print any page other than the first, invoke the NewPage
    ' method to perform a page break. The NewPage method advances to the next
    ' printer page and resets the print position to the upper-left corner of the
    ' new page.
    If mintPageCtr > 0 Then
        Printer.NewPage
    End If
    
    ' increment the page counter
    mintPageCtr = mintPageCtr + 1
    
    ' Print 4 blank lines, which provides a for top margin. These four lines do NOT
    ' count toward the limit of lines per page.
    Printer.Print
    Printer.Print
    Printer.Print
    Printer.Print
    
    ' Print the headers
    Printer.Print Tab(mintLINE_START_POS); _
                  "Print Date: "; _
                  Format$(Date, "mm/dd/yy"); _
                  Tab(mintLINE_START_POS + (((mintCharsPerLine - 19) \ 2) + 1)); _
                  "THEVBPROGRAMMER.COM"; _
                  Tab(mintLINE_START_POS + (mintCharsPerLine - 7)); _
                  "Page:"; _
                  Format$(mintPageCtr, "@@@")
    Printer.Print Tab(mintLINE_START_POS); _
                  "Print Time: "; _
                  Format$(Time, "hh:nn:ss"); _
                  Tab(mintLINE_START_POS + _
                      (((mintCharsPerLine - Len(mstrPrintFileName)) \ 2) + 1)); _
                  mstrPrintFileName
    Printer.Print
    
    ' reset the line counter to reflect the number of lines that have now
    ' been printed on the new page.
    mintLineCtr = 3

End Sub

